VERSION 5.00
Begin VB.Form frmMain 
   Appearance      =   0  '2D
   BackColor       =   &H80000005&
   BorderStyle     =   5  'nderbares Werkzeugfenster
   ClientHeight    =   3600
   ClientLeft      =   3720
   ClientTop       =   3360
   ClientWidth     =   4800
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ShowInTaskbar   =   0   'False
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   0
      Top             =   0
   End
   Begin VB.Menu mnuPROGRAMM 
      Caption         =   "&Programm"
      Begin VB.Menu mnuInfo 
         Caption         =   "&Info"
      End
      Begin VB.Menu SEPERATOR3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDRIVERS 
         Caption         =   ""
         Index           =   0
         Visible         =   0   'False
      End
      Begin VB.Menu mnuDRIVERS 
         Caption         =   ""
         Index           =   1
         Visible         =   0   'False
      End
      Begin VB.Menu mnuDRIVERS 
         Caption         =   ""
         Index           =   2
         Visible         =   0   'False
      End
      Begin VB.Menu mnuDRIVERS 
         Caption         =   ""
         Index           =   3
         Visible         =   0   'False
      End
      Begin VB.Menu mnuDRIVERS 
         Caption         =   ""
         Index           =   4
         Visible         =   0   'False
      End
      Begin VB.Menu mnuDRIVERS 
         Caption         =   ""
         Index           =   5
         Visible         =   0   'False
      End
      Begin VB.Menu SEPERATORDRIVERS 
         Caption         =   "-"
         Visible         =   0   'False
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit    [ESC]"
      End
   End
   Begin VB.Menu mnuRENDER 
      Caption         =   "&Render"
      Begin VB.Menu mnuFillPoints 
         Caption         =   "&Point"
         Shortcut        =   {F1}
      End
      Begin VB.Menu mnuFillWireFrame 
         Caption         =   "&Wireframe"
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuFillSolid 
         Caption         =   "&Solid"
         Shortcut        =   {F3}
      End
      Begin VB.Menu SEPERATOR5 
         Caption         =   "-"
      End
      Begin VB.Menu mnuShadeFlat 
         Caption         =   "&Flat"
         Shortcut        =   {F4}
      End
      Begin VB.Menu mnuShadeGouraud 
         Caption         =   "&Gouraud"
         Shortcut        =   {F5}
      End
      Begin VB.Menu mnuShadePhong 
         Caption         =   "&Phong"
         Shortcut        =   {F6}
      End
      Begin VB.Menu SEPERATOR6 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDitherOnOff 
         Caption         =   "&Dithering"
         Shortcut        =   {F7}
      End
      Begin VB.Menu mnuFogOnOff 
         Caption         =   "Fo&g"
         Shortcut        =   {F8}
      End
      Begin VB.Menu mnuLightOnOff 
         Caption         =   "&Light"
         Shortcut        =   {F9}
      End
      Begin VB.Menu mnuSEPERATORLIGHT 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTextureLinear 
         Caption         =   "Filter &Bilinear"
         Shortcut        =   {F11}
      End
      Begin VB.Menu mnuVISIER 
         Caption         =   "&Visier"
         Shortcut        =   {F12}
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const WORLDWIDTH As Long = 10 '1-50
Private Const WORLDDEPH As Long = 10  '1-50


'2D Stuff
Dim DD          As DirectDraw2
Dim Clipper     As DirectDrawClipper
Dim DDSFront    As DirectDrawSurface2
Dim DDSBack     As DirectDrawSurface2
Dim DDSPicture  As DirectDrawSurface2
Dim FX          As DDBLTFX
Dim FXPIC       As DDBLTFX
Dim picREC      As RECT
Dim srcREC      As RECT
Dim desREC      As RECT
Dim OldLeft     As Double
Dim OldTop      As Double

'3D Stuff
Dim D3D         As Direct3D2
Dim D3DRM       As Direct3DRM2
Dim D3DDevice   As Direct3DDevice2
Dim Device      As Direct3DRMDevice2
Dim WinDevice   As Direct3DRMWinDevice
Dim Viewport    As Direct3DRMViewPort
Dim ViewportShort As Direct3DRMViewPort

Dim Scene       As Direct3DRMFrame
Dim Camera      As Direct3DRMFrame
Dim CameraShort As Direct3DRMFrame
Dim WorldFrame  As Direct3DRMFrame
Dim SphereFrame As Direct3DRMFrame
Dim SpotFrame   As Direct3DRMFrame

Dim Anim        As Direct3DRMAnimation
Dim AnimStart   As Long
Dim Cam         As D3DVECTOR
Dim Pickeds     As Direct3DRMPickedArray


'Renderoption
Dim DitherMode  As Long
Dim FogMode     As Long
Dim LightMode   As Long
Dim FillMode    As Long
Dim ShadeMode   As Long
Dim TextureMode As Long
Dim ViewMode    As Long
Dim VisierMode  As Long

Private Sub BuildWorld(ByVal w As Long, ByVal h As Long)

'  the result is an chassfield

  Dim x As Long
  Dim y As Single
  Dim z As Long
  
  Dim i As Single

  Dim NumOfVertices   As Long
  Dim Vertices()      As D3DVECTOR
  Dim NumOfNormals    As Long
  Dim Normals(1 To 1) As D3DVECTOR
  Dim NumOfFaces      As Long
  Dim FaceData()      As Long
    
  Dim FC              As Long
  Dim P               As Long
  
  Dim Meshbuilder     As Direct3DRMMeshBuilder
  Dim Faces           As Direct3DRMFaceArray
  Dim Face            As Direct3DRMFace
      
  If w < 2 Then w = 2
  If h < 2 Then h = 2
  w = w \ 2: w = w * 2
  h = h \ 2: h = h * 2
  ReDim Vertices(1 To (w + 1) * (h + 1))
  ReDim FaceData(1 To w * h * 5 + 1)
  
  For z = (h \ 2) To -(h \ 2) Step -1
    For x = -(w \ 2) To (w \ 2)
      NumOfVertices = NumOfVertices + 1
      With Vertices(NumOfVertices)
        .x = x
        .z = z
        .y = 0
      End With
    Next
  Next
  
  For z = 0 To h - 1
    For x = 0 To w - 1
      P = z * (w + 1) + x
      FC = FC + 1
      FaceData(FC) = 4
      
      FC = FC + 1
      FaceData(FC) = P
      
      FC = FC + 1
      FaceData(FC) = P + 1
      
      FC = FC + 1
      FaceData(FC) = P + (w + 2)
      
      FC = FC + 1
      FaceData(FC) = P + (w + 1)
      
      NumOfFaces = NumOfFaces + 1
    Next
  Next
  
  'Terminator
  FaceData(FC + 1) = 0
    
  'Interface Meshbuilder
  D3DRM.CreateMeshBuilder Meshbuilder
  With Meshbuilder
    .AddFaces NumOfVertices, Vertices(1), 0, Normals(1), FaceData(1), Faces
    .[Scale] 2, 1, 2
    .GenerateNormals
    .SetQuality D3DRMFILL_SOLID Or D3DRMSHADE_PHONG Or D3DRMLIGHT_ON
  End With
  
  For z = 0 To h - 1
    For x = 0 To w - 1
      i = z * w + x
      Faces.GetElement i, Face
      
      If (z And 1) = 1 Then
        If (x And 1) Then
          Face.SetColorRGB 0.3, 0.3, 0.3
        Else
          Face.SetColorRGB 1, 1, 1
        End If
      Else
        If (x And 1) Then
          Face.SetColorRGB 1, 1, 1
        Else
          Face.SetColorRGB 0.3, 0.3, 0.3
        End If
      End If
    Next
  Next
  
  WorldFrame.AddVisual Meshbuilder
  Set Meshbuilder = Nothing
End Sub

Private Sub Form_Activate()
  'if exist an WinDevice than let it handle the Message
  If (WinDevice Is Nothing) Then Exit Sub
  WinDevice.HandleActivate Me.WindowState
End Sub

Private Sub Form_Paint()
  'if exist an WinDevice than let it handle the Message
  If (WinDevice Is Nothing) Then Exit Sub
  WinDevice.HandlePaint Me.hdc
End Sub
'The handle all MENU Messages
Private Sub mnuDitherOnOff_Click()
  Timer1.Enabled = False
  If DitherMode = 1 Then
    mnuDitherOnOff.Checked = False
    DitherMode = 0
  Else
    mnuDitherOnOff.Checked = True
    DitherMode = 1
  End If
  Form_Resize
  Timer1.Enabled = True
End Sub
Private Sub mnuFogOnOff_Click()
  Timer1.Enabled = False
  If FogMode = 1 Then
    mnuFogOnOff.Checked = False
    FogMode = 0
  Else
    mnuFogOnOff.Checked = True
    FogMode = 1
  End If
  Form_Resize
  Timer1.Enabled = True
End Sub
Private Sub mnuEXIT_Click()
  Timer1.Enabled = False
  Unload Me
  
End Sub

Private Sub mnuLightOnOff_Click()
  Timer1.Enabled = False
  If LightMode = D3DRMLIGHT_ON Then
    mnuLightOnOff.Checked = False
    LightMode = D3DRMLIGHT_OFF
  Else
    mnuLightOnOff.Checked = True
    LightMode = D3DRMLIGHT_ON
  End If
  Form_Resize
  Timer1.Enabled = True
End Sub


Private Sub mnushadeFLAT_Click()
  Timer1.Enabled = False
  ShadeMode = D3DRMSHADE_FLAT
  mnuShadeFlat.Checked = True
  mnuShadeGouraud.Checked = False
  mnuShadePhong.Checked = False
  Form_Resize
  Timer1.Enabled = True
End Sub

Private Static Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error Resume Next
    
  If Shift = 0 Then
    Select Case KeyCode
      Case vbKeyEscape
        Timer1.Enabled = False
        Unload Me
        
      Case vbKeyUp
        Camera.GetPosition Scene, Cam
        Cam.z = Cam.z + 0.5!
        Camera.SetPosition Scene, Cam.x, Cam.y, Cam.z
        
      Case vbKeyDown
        Camera.GetPosition Scene, Cam
        Cam.z = Cam.z - 0.5!
        Camera.SetPosition Scene, Cam.x, Cam.y, Cam.z
        
      Case vbKeyLeft
        Camera.GetPosition Scene, Cam
        Cam.x = Cam.x - 0.5!
        Camera.SetPosition Scene, Cam.x, Cam.y, Cam.z
        
      Case vbKeyRight
        Camera.GetPosition Scene, Cam
        Cam.x = Cam.x + 0.5!
        Camera.SetPosition Scene, Cam.x, Cam.y, Cam.z
        
       
    End Select
  Else
    Select Case Shift
      Case vbShiftMask
      Case vbCtrlMask
      Select Case KeyCode
        Case vbKeyUp
          Camera.GetPosition Scene, Cam
          Cam.y = Cam.y + 0.5!
          Camera.SetPosition Scene, Cam.x, Cam.y, Cam.z
          
        Case vbKeyDown
          Camera.GetPosition Scene, Cam
          Cam.y = Cam.y - 0.5!
          Camera.SetPosition Scene, Cam.x, Cam.y, Cam.z
          
      End Select
      Case vbAltMask
    End Select
  End If
  If Err Then Err.Clear
End Sub


Private Sub Form_Resize()
     
  Dim DDSD As DDSURFACEDESC
  Dim DDSC As DDSCAPS
  
  Me.MousePointer = vbSizeAll
  'Buffers was build on DirectDraw2
  If Not (DDSBack Is Nothing) Then Set DDSBack = Nothing
  If Not (DDSFront Is Nothing) Then Set DDSFront = Nothing
  If Not (DDSPicture Is Nothing) Then Set DDSPicture = Nothing

  'Object.Release
  'Viewport was build on Device
  If Not (Viewport Is Nothing) Then Set Viewport = Nothing
  If Not (ViewportShort Is Nothing) Then Set ViewportShort = Nothing
  'Windevice was build on device too
  If Not (WinDevice Is Nothing) Then Set WinDevice = Nothing
  'Device was build DDSBack
  If Not (Device Is Nothing) Then Set Device = Nothing
  'Clipper was build on DirectDraw.DLL
  If Not (Clipper Is Nothing) Then Set Clipper = Nothing
  

 
  'nothing to do
  If Me.WindowState = vbMinimized Then Exit Sub
  If (Me.ScaleWidth = 0) Or (Me.ScaleHeight = 0) Then Exit Sub
  
  'Is selected Driver a Ramp/Mono Emualtion then disenable Fog
  If Drivers(CurDriver).EMU And Drivers(CurDriver).MONO Then
    FogMode = 0
    mnuFogOnOff.Enabled = False
  Else
    mnuFogOnOff.Enabled = True
    FogMode = IIf(mnuFogOnOff.Checked, 1, 0)
  End If
      
  DD.SetCooperativeLevel ByVal 0&, DDSCL_NORMAL
  
  
  'Interface-Clipper
  DirectDrawCreateClipper ByVal 0&, Clipper, Nothing
  
  'Cliplist from Window
  Clipper.SetHWnd 0, Me.hWND
  'create visible Frontsurface
  With DDSD
    .dwSize = Len(DDSD)
    .dwFlags = DDSD_CAPS
    .DDSCAPS.dwCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_SYSTEMMEMORY
  End With
  DD.CreateSurface DDSD, DDSFront, Nothing
  DDSFront.SetClipper Clipper
  
  'create nonvisible Backgroundsurface
  With DDSD
    .dwSize = Len(DDSD)
    .dwWidth = Me.ScaleWidth
    .dwHeight = Me.ScaleHeight
    .DDSCAPS.dwCaps = DDSCAPS_OFFSCREENPLAIN Or _
                      DDSCAPS_SYSTEMMEMORY Or _
                      DDSCAPS_3DDEVICE
    .dwFlags = DDSD_CAPS Or _
               DDSD_WIDTH Or _
               DDSD_HEIGHT
  End With
  DD.CreateSurface DDSD, DDSBack, Nothing
  'Set Pallete if we are in 8BPP (Palettemode)
  If GetDeviceCaps(Me.hdc, GDC_BitPerPixel) = 8 Then
    Dim ColTable(0 To 255) As PALETTEENTRY
    Dim pc As Long
    Dim HRESULT As Long
    Dim Palette As DirectDrawPalette
    HRESULT = GetSystemPaletteEntries(Me.hdc, 0, 256, ColTable(0))
    For pc = 0 To 255
      ColTable(pc).peFlags = &H40
    Next
    DD.CreatePalette 4, ColTable(0), Palette, Nothing
    DDSBack.SetPalette Palette
    Set Palette = Nothing
  End If

  'Interface Device
  D3DRM.CreateDeviceFromSurface Drivers(CurDriver).GUID, _
                                DD, _
                                DDSBack, _
                                Device
  
 
  
  If VisierMode Then
    'Load Picture in Surface
    CreateSurfaceFromFile DD, _
                          DDSPicture, _
                          Me, _
                          Me.ScaleWidth, _
                          Me.ScaleHeight, _
                          ApplicationPath & "glasses.bmp"
    'set White as an transparent Color
    SetColKey DDSPicture, RGB(255, 255, 255)
  End If
   
  
  'Device.QueryInterface IID_WINDEVICE, ...
  Set WinDevice = Device
    
  'Set all Renderoption and create an Viewport
  With Device
    .SetTextureQuality TextureMode
    .SetDither DitherMode
    .SetQuality FillMode Or ShadeMode Or LightMode
    .SetRenderMode 3
'    Select Case BPP
'      Case 8
'        .SetShades 4
'        D3DRM.SetDefaultTextureShades 4
'      Case 16
'        .SetShades 32
'        D3DRM.SetDefaultTextureColors 64
'        D3DRM.SetDefaultTextureShades 32
'      Case 24, 32
'        .SetShades 256
'        D3DRM.SetDefaultTextureColors 64
'        D3DRM.SetDefaultTextureShades 256
'    End Select
    
  End With
  
  'Interface-Viewport
  D3DRM.CreateViewport Device, _
                       Camera, _
                       0, 0, _
                       Device.GetWidth, _
                       Device.GetHeight, _
                       Viewport
  
  If VisierMode Then
    D3DRM.CreateViewport Device, _
                         CameraShort, _
                         0, _
                         0, _
                         Device.GetWidth \ 4, _
                         Device.GetHeight \ 4, _
                         ViewportShort
    ViewportShort.SetBack 50!
  End If
  
  With Viewport
    .SetBack 15!
    .SetProjection D3DRMPROJECT_PERSPECTIVE
    .SetUniformScaling True
  End With
  
  picREC.Left = 0
  picREC.Top = 0
  picREC.Right = Me.ScaleWidth
  picREC.bottom = Me.ScaleHeight
  
  
  srcREC.Left = 0
  srcREC.Top = 0
  srcREC.Right = Device.GetWidth
  srcREC.bottom = Device.GetHeight
  
  desREC.Left = (Me.Left / Screen.TwipsPerPixelX) + 4
  desREC.Top = (Me.Top / Screen.TwipsPerPixelY) + 38 'Menuheight
  desREC.Right = desREC.Left + Me.ScaleWidth
  desREC.bottom = desREC.Top + Me.ScaleHeight
  Scene.SetSceneFogEnable FogMode
    
  OldLeft = Me.Left
  OldTop = Me.Top
  
    
  Me.MousePointer = vbDefault
End Sub
Private Sub Form_Unload(Cancel As Integer)
  If Not (DD Is Nothing) Then
    DD.SetCooperativeLevel Me.hWND, DDSCL_NORMAL
  End If
  
  'Object.Release  clear all Objects in backward order
  Set Anim = Nothing
  Set SphereFrame = Nothing
  Set WorldFrame = Nothing
  Set SpotFrame = Nothing
  Set Camera = Nothing
  Set CameraShort = Nothing
  Set Scene = Nothing
    
  Set Viewport = Nothing  'Viewport was build on Device
  Set ViewportShort = Nothing '               on Device
  Set WinDevice = Nothing '                   on Device
  Set Device = Nothing '                      on Surface
  Set Clipper = Nothing '                     on DirectDraw.DLL
  Set DDSBack = Nothing '                     on DD
  Set DDSFront = Nothing '                    on DD
  Set DDSPicture = Nothing '                  on DD
  Set D3DRM = Nothing '                       on D3DRM.DLL
  Set D3D = Nothing '                         on DD
  Set DD = Nothing '                          on DirectDraw.DLL
End Sub
Private Sub Form_Load()
  Dim AmbientLight    As Direct3DRMLight
  Dim SpotLight       As Direct3DRMLight
  Dim Meshbuilder     As Direct3DRMMeshBuilder
  Dim Shadow          As Direct3DRMVisual
  Dim SphereColor     As Long
  Dim i               As Long
    
  On Error Resume Next
    
  FX.dwSize = Len(FX)
  FX.dwRop = vbSrcCopy
  FXPIC.dwSize = Len(FXPIC)
  FXPIC.dwRop = vbSrcAnd
  'Get curent ColorModel
  BPP = GetDeviceCaps(Me.hdc, GDC_BitPerPixel)
  If BPP < 8 Then
    MsgBox "Please run this Demo 8,16,24 or 32 BPP", vbInformation
    Timer1.Enabled = False
    Unload Me
  End If
    
  'Set all Rendermodes and Menu
  ShadeMode = D3DRMSHADE_GOURAUD
  FillMode = D3DRMFILL_SOLID
  DitherMode = 0
  LightMode = D3DRMLIGHT_ON
  TextureMode = D3DRMTEXTURE_NEAREST
  FogMode = 0
  VisierMode = 1
  
  mnuFillSolid.Checked = True
  mnuShadeGouraud.Checked = True
  mnuDitherOnOff.Checked = False
  mnuLightOnOff.Checked = True
  mnuFogOnOff.Checked = False
  mnuVISIER.Checked = True
  
  DirectDrawCreate ByVal 0&, DD, Nothing
  If Err Then modDirectXError.D3DRMERROR Err.Number, "DirectDrawCreate", True
  
  'DD.QueryInterface IIDDirect3D,...
  Set D3D = DD
  If Err Then modDirectXError.D3DRMERROR Err.Number, "Set D3D=DD", True
  
  Direct3DRMCreate D3DRM
  If Err Then modDirectXError.D3DRMERROR Err.Number, "Direct3DRMCreate D3DRM", True
  
  'Get all Supported Direct3D Drivers
  'this can be Emulated or in Hardware
  D3D.EnumDevices AddressOf EnumDeviceCallback, 0
  If Err Then modDirectXError.D3DRMERROR Err.Number, "D3D.EnumDevices", True
  
  'No Driver no fun
  If NumOfDrivers = 0 Then
    MsgBox "Can't find any supported Direct3D Driver", vbCritical, "Programm halted"
    Set D3D = Nothing
    Set DD = Nothing
    End
  End If
  'Place Drivers in Menu
  For i = 0 To NumOfDrivers - 1
    mnuDRIVERS(i).Caption = Drivers(i).NAME
    mnuDRIVERS(i).Visible = True
  Next
  SEPERATORDRIVERS.Visible = True
  'CurDriver is the first aviable Driver with Index = 0
  mnuDRIVERS(CurDriver).Checked = True
  
  'No complex Treestructure
  D3DRM.CreateFrame Nothing, Scene
  D3DRM.CreateFrame Scene, WorldFrame
  D3DRM.CreateFrame Scene, Camera
  D3DRM.CreateFrame Scene, CameraShort
  D3DRM.CreateFrame Scene, SphereFrame
  D3DRM.CreateFrame Scene, SpotFrame
    
  Camera.SetPosition Scene, 1, 5, -1
  Camera.LookAt Scene, Nothing, D3DRMCONSTRAIN_Z
  
  CameraShort.SetPosition Scene, 0, 20, 0
  CameraShort.LookAt Scene, Nothing, D3DRMCONSTRAIN_Z
  
  'Create Ambient SceneLight
  D3DRM.CreateLightRGB D3DRMLIGHT_AMBIENT, 0.5, 0.5, 0.5, AmbientLight
  Scene.AddLight AmbientLight
  Set AmbientLight = Nothing
    
  'Build Chessfield width*deph
  BuildWorld WORLDWIDTH, WORLDDEPH
  
  'Load simple Sphere and make it red transparent
  SphereColor = D3DRMCreateColorRGBA(0.7!, 0!, 0!, 0.75!)
  D3DRM.CreateMeshBuilder Meshbuilder
  With Meshbuilder
    .Load ApplicationPath & "Sphere2.x", 0, 0, 0, 0
    If Err Then modDirectXError.D3DRMERROR Err.Number, "Meshbuilder.Load", True
    .[Scale] 0.5!, 0.5!, 0.5!
    .SetQuality D3DRMFILL_SOLID Or D3DRMSHADE_PHONG Or D3DRMLIGHT_ON
    .SetColor SphereColor
  End With
  
  'Create Spotlight
  D3DRM.CreateLightRGB D3DRMLIGHT_SPOT, 1, 1, 0, SpotLight
  With SpotLight
    .SetPenumbra 0.2 'outer Cone
    .SetUmbra 0.15   'inner Cone
    .SetRange 40!
  End With
  'Ceate Shadow
  D3DRM.CreateShadow Meshbuilder, _
                     SpotLight, _
                     0, 0.1, 0, _
                     0, 2, 0, Shadow
  SphereFrame.AddVisual Meshbuilder
  SphereFrame.AddVisual Shadow
   
  Set Meshbuilder = Nothing
  Set Shadow = Nothing
  
  With SpotFrame
    .AddLight SpotLight
    .SetPosition Scene, 0, 35, 0
  End With
  Set SpotLight = Nothing
    
  'simple animated Chessfield
  WorldFrame.SetRotation Scene, 0, 20, 0, PIm2 / 180
  'simple animated Sphere
  SphereFrame.SetRotation Scene, 0, 1, 0, PIm2 / 60
  
  'Interface-IAnimation
  D3DRM.CreateAnimation Anim
  
  With Anim
    'Create an Spline Poisition Path and animate it everytime
    .SetOptions D3DRMANIMATIONOPTIONS.D3DRMANIMATION_CLOSED Or _
                D3DRMANIMATIONOPTIONS.D3DRMANIMATION_POSITION Or _
                D3DRMANIMATIONOPTIONS.D3DRMANIMATION_SPLINEPOSITION
  
    'Set the Sphere on the Path
    .SetFrame SphereFrame
  
    'Define the Key-Position on the Path
    .AddPositionKey 0, -7, 1, 3
    .AddPositionKey 20, 5, 1, 0
    .AddPositionKey 40, 7, 1, -5
    .AddPositionKey 60, -2, 1, -3
    .AddPositionKey 80, -7, 1, 3
  End With
  
  'Set up the Scene
  With Scene
    .SetSceneBackgroundRGB 0.25, 0.5, 0.5
    .SetSceneFogMode D3DRMFOG_EXPONENTIAL
    .SetSceneFogColor &H207070
    .SetSceneFogParams 8!, 15!, 0.1!
  End With
  
  'Save Curent Time
  AnimStart = Timer
  
  'Enable the Renderloop
  Timer1.Enabled = True
  
End Sub
Private Sub mnuShadeGOURAUD_Click()
  Timer1.Enabled = False
  ShadeMode = D3DRMSHADE_GOURAUD
  mnuShadeFlat.Checked = False
  mnuShadeGouraud.Checked = True
  mnuShadePhong.Checked = False
  Form_Resize 'Create new Clipper,Device,WinDevice,Viewport
  Timer1.Enabled = True
End Sub
Private Sub mnuDRIVERS_Click(Index As Integer)
  Timer1.Enabled = False
  Dim i As Long
  For i = 0 To MAX_DRIVER
    mnuDRIVERS(i).Checked = False
  Next
  mnuDRIVERS(Index).Checked = True
  CurDriver = Index
  Form_Resize 'Create new Clipper,Device,WinDevice,Viewport
  Timer1.Enabled = True
End Sub
Private Sub mnuTextureLINEAR_Click()
  Timer1.Enabled = True
  If TextureMode = D3DRMTEXTURE_LINEAR Then
    mnuTextureLinear.Checked = False
    TextureMode = D3DRMTEXTURE_NEAREST
  Else
    mnuTextureLinear.Checked = True
    TextureMode = D3DRMTEXTURE_LINEAR
  End If
  Form_Resize 'Create new Clipper,Device,WinDevice,Viewport
  Timer1.Enabled = True
End Sub
Private Sub mnuShadePhong_Click()
  Timer1.Enabled = False
  ShadeMode = D3DRMSHADE_PHONG
  mnuShadeFlat.Checked = False
  mnuShadeGouraud.Checked = False
  mnuShadePhong.Checked = True
  Form_Resize 'Create new Clipper,Device,WinDevice,Viewport
  Timer1.Enabled = True
End Sub
Private Sub mnuFillPOINTS_Click()
  Timer1.Enabled = False
  FillMode = D3DRMFILL_POINTS
  mnuFillPoints.Checked = True
  mnuFillWireFrame.Checked = False
  mnuFillSolid.Checked = False
  Form_Resize 'Create ew Clipper,Device,WinDevice,Viewport
  Timer1.Enabled = True
End Sub
Private Sub mnuFillWIREFRAME_Click()
  Timer1.Enabled = False
  FillMode = D3DRMFILL_WIREFRAME
  mnuFillPoints.Checked = False
  mnuFillWireFrame.Checked = True
  mnuFillSolid.Checked = False
  Form_Resize 'Create new Clipper,Device,WinDevice,Viewport
  Timer1.Enabled = True
End Sub
Private Sub mnuFillSOLID_Click()
  Timer1.Enabled = False
  FillMode = D3DRMFILL_SOLID
  mnuFillPoints.Checked = False
  mnuFillWireFrame.Checked = False
  mnuFillSolid.Checked = True
  Form_Resize 'Create new Clipper,Device,WinDevice,Viewport
  Timer1.Enabled = True
End Sub

Private Sub mnuVISIER_Click()
  Timer1.Enabled = False
  If VisierMode Then
    mnuVISIER.Checked = False
    VisierMode = 0
  Else
    mnuVISIER.Checked = True
    VisierMode = 1
  End If
  Form_Resize
  Timer1.Enabled = True
End Sub

Private Sub Timer1_Timer()
  'Render- and Animationloop
  
  Dim t As Single
  Dim CurTime As Single
  Dim hdc As Long
  Dim PSetCol As Long
  Dim x As Long
  Dim y As Long
  Dim i As Long
  'Nothing to render ?
  If Viewport Is Nothing Then Exit Sub
  
  On Error Resume Next
  t = Timer + 10
  
  Do
    If (Viewport Is Nothing) Then Exit Do 'Change in Form_Resize ?
    If OldLeft <> Me.Left Or OldTop <> Me.Top Then Form_Resize

    CurTime = Timer - AnimStart
    Anim.SetTime CurTime
    SpotFrame.LookAt SphereFrame, Scene, D3DRMCONSTRAIN_X
    Camera.LookAt SphereFrame, Scene, D3DRMCONSTRAIN_Z
    Scene.Move 1!
    Viewport.Clear
    Viewport.Render Scene
    
    If VisierMode Then
      DDSPicture.ReleaseDC hdc
      DDSBack.BltFast 0, 0, _
                      DDSPicture, _
                      picREC, _
                      DDBLTFAST_SRCCOLORKEY Or _
                      DDBLTFAST_WAIT
       
      ViewportShort.Clear
      ViewportShort.Render Scene
    End If
    
    
    'Device.Update=copy Backbuffer in visible Frontbuffer
    DDSFront.Blt desREC, _
                 DDSBack, _
                 srcREC, _
                 DDBLT_ROP Or DDBLT_WAIT, _
                 FX
    DoEvents    'give the messageloop time to handle messages
  Loop While Timer < t
End Sub
